-- description: A voice replacement mod for Mario, \nWario, and Luigi.\n\nThe voices are from Render96 (Before the recent update)\n\nI made this to test how well I'd do in this modding community.\n\nHope everyone enjoys!\n\nCreated by: 64marioo\n\nVoice Replacement Code: xXMoonDarklyXx\n\nVoice Acting: Andrat, GenesisJam, Zephyr, and Diario\n\nThanks to the ENTIRE Render96 team for assets used and inspiration <3


for i=0,(MAX_PLAYERS-1) do
    local s = gPlayerSyncTable[i]
    s.heMario = false
end
--From here on this is all SMS Alfredo's custom voice resource

local function use_custom_voice(m)
    local s = gPlayerSyncTable[m.playerIndex]
    return m.character.type == 4
end

--How many snores the sleep-talk has, or rather, how long the sleep-talk lasts
--If you omit the sleep-talk you can ignore this
local SLEEP_TALK_SNORES = 4

--Define what actions play what voice clips
--If an action has more than one voice clip, put those clips inside a table
--CHAR_SOUND_SNORING3 requires two or three voice clips to work properly...
--but you can omit it if your character does not sleep-talk
local CUSTOM_VOICETABLE = {
    	[CHAR_SOUND_OKEY_DOKEY] = 'LetsGo_W96.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'LetsGo_W96.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Jump3_W96.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Jump2_W96.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Punch3_W96.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Jump1_W96.ogg', 'Jump2_W96.ogg', 'Jump3_W96.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Hoohoo_W96.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Triple1_W96.ogg', 'LongJump_W96.ogg', 'Triple2_W96.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Uh_W96.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'LedgeAndLandLong_W96.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'LedgeAndLandLong_W96.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Haha_W96.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'LongJump_W96.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Doh_W96.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'FallLedge_W96.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'ClimbLedge_W96.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'LongFall_W96.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'Yeahh_W96.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Groundpound_W96.ogg', 
	[CHAR_SOUND_HRMM] = 'PickUp_W96.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'HereWeGo_W96.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'SoLongBowser_W96.ogg', -- Throwing Bowser
 	[CHAR_SOUND_OOOF] = 'Oof_W96.ogg',
 	[CHAR_SOUND_OOOF2] = 'Oof_W96.ogg',
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Damaged_W96.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'LowPant_W96.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Lava_W96.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Tired_W96.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Yawn_W96.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'YawnInhale_W96.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'YawnExhale_W96.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'DreamTalk_W96.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Cough1_W96.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Cough1_W96.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Cough1_W96.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Dying_W96.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Drowning_W96.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Mamamia_W96.ogg' -- Booted out of level
}

--Define the table of samples that will be used for each player
--Global so if multiple mods use this they won't create unneeded samples
--DON'T MODIFY THIS SINCE IT'S GLOBAL FOR USE BY OTHER MODS!
gCustomVoiceSamples = {}
gCustomVoiceStream = nil

function stop_custom_character_sound(m, sound)
    local voice_sample = gCustomVoiceSamples[m.playerIndex]
    if voice_sample == nil or not voice_sample.loaded then
        return
    end

    audio_sample_stop(voice_sample)
    if voice_sample.file.relativePath:match('^.+/(.+)$') == sound then
        return voice_sample
    end
    -- audio_sample_destroy(voice_sample)
end

--Play a custom character's sound
--DON'T MODIFY THIS SINCE IT'S GLOBAL FOR USE BY OTHER MODS!
--- @param m MarioState
function play_custom_character_sound(m, voice)
    --Get sound, if it's a table, get a random entry from it
    local sound
    if type(voice) == "table" then
        sound = voice[math.random(#voice)]
    else
        sound = voice
    end
    if sound == nil then return 0 end

    --Get current sample and stop it
    local voice_sample = stop_custom_character_sound(m, sound)

    --If the new sound isn't a string, let's assume it's
    --a number to return to the character sound hook
    if type(sound) ~= "string" then
        return sound
    end

    --Load a new sample and play it! Don't make a new one if we don't need to
    if (m.area == nil or m.area.camera == nil) and m.playerIndex == 0 then
        if gCustomVoiceStream ~= nil then
            audio_stream_stop(gCustomVoiceStream)
            audio_stream_destroy(gCustomVoiceStream)
        end
        gCustomVoiceStream = audio_stream_load(sound)
        audio_stream_play(gCustomVoiceStream, true, 1)
    else
        if voice_sample == nil then
            voice_sample = audio_sample_load(sound)
        end
        audio_sample_play(voice_sample, m.pos, 1)

        gCustomVoiceSamples[m.playerIndex] = voice_sample
    end
    return 0
end

--Main character sound hook
--This hook is freely modifiable in case you want to make any specific exceptions
--- @param m MarioState
local function custom_character_sound(m, characterSound)
    if not use_custom_voice(m) or is_game_paused() then return end
    if characterSound == CHAR_SOUND_SNORING3 then return 0 end
    if characterSound == CHAR_SOUND_HAHA and m.hurtCounter > 0 then return 0 end

    local voice = CUSTOM_VOICETABLE[characterSound]
    if voice ~= nil then
        return play_custom_character_sound(m, voice)
    end
    return 0
end
hook_event(HOOK_CHARACTER_SOUND, custom_character_sound)

--Snoring logic for CHAR_SOUND_SNORING3 since we have to loop it manually
--This code won't activate on the Japanese version, due to MARIO_MARIO_SOUND_PLAYED not being set

local SNORE3_TABLE = CUSTOM_VOICETABLE[CHAR_SOUND_SNORING3]
local STARTING_SNORE = 46
local SLEEP_TALK_START = STARTING_SNORE + 49
local SLEEP_TALK_END = SLEEP_TALK_START + SLEEP_TALK_SNORES

--Main hook for snoring
--- @param m MarioState
local function custom_character_snore(m)
    if not use_custom_voice(m) then return end

    --Stop the snoring!
    if m.action ~= ACT_SLEEPING then
        if m.isSnoring > 0 then
            stop_custom_character_sound(m)
        end
        return

    --You're not in deep snoring
    elseif not (m.actionState == 2 and (m.flags & MARIO_MARIO_SOUND_PLAYED) ~= 0) then
        return
    end

    local animFrame = m.marioObj.header.gfx.animInfo.animFrame

    --Behavior for CHAR_SOUND_SNORING3
    if SNORE3_TABLE ~= nil and #SNORE3_TABLE >= 2 then
        --Exhale sound
        if animFrame == 2 and m.actionTimer < SLEEP_TALK_START then
            play_custom_character_sound(m, SNORE3_TABLE[2])

        --Inhale sound
        elseif animFrame == 25 then
            
            --Count up snores
            if #SNORE3_TABLE >= 3 then
                m.actionTimer = m.actionTimer + 1

                --End sleep-talk
                if m.actionTimer >= SLEEP_TALK_END then
                    m.actionTimer = STARTING_SNORE
                end
    
                --Enough snores? Start sleep-talk
                if m.actionTimer == SLEEP_TALK_START then
                    play_custom_character_sound(m, SNORE3_TABLE[3])
                
                --Regular snoring
                elseif m.actionTimer < SLEEP_TALK_START then
                    play_custom_character_sound(m, SNORE3_TABLE[1])
                end
            
            --Definitely regular snoring
            else
                play_custom_character_sound(m, SNORE3_TABLE[1])
            end
        end

    --No CHAR_SOUND_SNORING3, just use regular snoring
    elseif animFrame == 2 then
        play_character_sound(m, CHAR_SOUND_SNORING2)

    elseif animFrame == 25 then
        play_character_sound(m, CHAR_SOUND_SNORING1)
    end
end

hook_event(HOOK_MARIO_UPDATE, custom_character_snore)

------------------------------

local function use_custom_voice(m)
    local s = gPlayerSyncTable[m.playerIndex]
    return m.character.type == 0
end

--How many snores the sleep-talk has, or rather, how long the sleep-talk lasts
--If you omit the sleep-talk you can ignore this
local SLEEP_TALK_SNORES = 1

--Define what actions play what voice clips
--If an action has more than one voice clip, put those clips inside a table
--CHAR_SOUND_SNORING3 requires two or three voice clips to work properly...
--but you can omit it if your character does not sleep-talk
local CUSTOM_VOICETABLE = {
    	[CHAR_SOUND_OKEY_DOKEY] = 'LetsGo_M96.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'LetsGo_M96.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Jump3_M96.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Jump2_M96.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Punch3_M96.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Jump1_M96.ogg', 'Jump2_M96.ogg', 'Jump3_M96.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Hoohoo_M96.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Triple1_M96.ogg', 'LongJump_M96.ogg', 'Triple2_M96.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Uh_M96.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'LedgeAndLandLong_M96.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'LedgeAndLandLong_M96.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Haha_M96.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'LongJump_M96.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Doh_M96.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'FallLedge_M96.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'ClimbLedge_M96.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'LongFall_M96.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'Boing_M96.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Groundpound_M96.ogg', 
	[CHAR_SOUND_HRMM] = 'PickUp_M96.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'HereWeGo_M96.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'SoLongBowser_M96.ogg', -- Throwing Bowser
 	[CHAR_SOUND_OOOF] = 'Oof_M96.ogg',
 	[CHAR_SOUND_OOOF2] = 'Oof_M96.ogg',
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Damaged_M96.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'LowPant_M96.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Lava_M96.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Tired_M96.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Yawn_M96.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'YawnInhale_M96.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'YawnExhale_M96.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'DreamTalk_M96.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Cough1_M96.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Cough1_M96.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Cough1_M96.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Dying_M96.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Drowning_M96.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Mamamia_M96.ogg' -- Booted out of level
}

--Define the table of samples that will be used for each player
--Global so if multiple mods use this they won't create unneeded samples
--DON'T MODIFY THIS SINCE IT'S GLOBAL FOR USE BY OTHER MODS!
gCustomVoiceSamples = {}
gCustomVoiceStream = nil

function stop_custom_character_sound(m, sound)
    local voice_sample = gCustomVoiceSamples[m.playerIndex]
    if voice_sample == nil or not voice_sample.loaded then
        return
    end

    audio_sample_stop(voice_sample)
    if voice_sample.file.relativePath:match('^.+/(.+)$') == sound then
        return voice_sample
    end
    -- audio_sample_destroy(voice_sample)
end

--Play a custom character's sound
--DON'T MODIFY THIS SINCE IT'S GLOBAL FOR USE BY OTHER MODS!
--- @param m MarioState
function play_custom_character_sound(m, voice)
    --Get sound, if it's a table, get a random entry from it
    local sound
    if type(voice) == "table" then
        sound = voice[math.random(#voice)]
    else
        sound = voice
    end
    if sound == nil then return 0 end

    --Get current sample and stop it
    local voice_sample = stop_custom_character_sound(m, sound)

    --If the new sound isn't a string, let's assume it's
    --a number to return to the character sound hook
    if type(sound) ~= "string" then
        return sound
    end

    --Load a new sample and play it! Don't make a new one if we don't need to
    if (m.area == nil or m.area.camera == nil) and m.playerIndex == 0 then
        if gCustomVoiceStream ~= nil then
            audio_stream_stop(gCustomVoiceStream)
            audio_stream_destroy(gCustomVoiceStream)
        end
        gCustomVoiceStream = audio_stream_load(sound)
        audio_stream_play(gCustomVoiceStream, true, 1)
    else
        if voice_sample == nil then
            voice_sample = audio_sample_load(sound)
        end
        audio_sample_play(voice_sample, m.pos, 1)

        gCustomVoiceSamples[m.playerIndex] = voice_sample
    end
    return 0
end

--Main character sound hook
--This hook is freely modifiable in case you want to make any specific exceptions
--- @param m MarioState
local function custom_character_sound(m, characterSound)
    if not use_custom_voice(m) or is_game_paused() then return end
    if characterSound == CHAR_SOUND_SNORING3 then return 0 end
    if characterSound == CHAR_SOUND_HAHA and m.hurtCounter > 0 then return 0 end

    local voice = CUSTOM_VOICETABLE[characterSound]
    if voice ~= nil then
        return play_custom_character_sound(m, voice)
    end
    return 0
end
hook_event(HOOK_CHARACTER_SOUND, custom_character_sound)

--Snoring logic for CHAR_SOUND_SNORING3 since we have to loop it manually
--This code won't activate on the Japanese version, due to MARIO_MARIO_SOUND_PLAYED not being set

local SNORE3_TABLE = CUSTOM_VOICETABLE[CHAR_SOUND_SNORING3]
local STARTING_SNORE = 46
local SLEEP_TALK_START = STARTING_SNORE + 49
local SLEEP_TALK_END = SLEEP_TALK_START + SLEEP_TALK_SNORES

--Main hook for snoring
--- @param m MarioState
local function custom_character_snore(m)
    if not use_custom_voice(m) then return end

    --Stop the snoring!
    if m.action ~= ACT_SLEEPING then
        if m.isSnoring > 0 then
            stop_custom_character_sound(m)
        end
        return

    --You're not in deep snoring
    elseif not (m.actionState == 2 and (m.flags & MARIO_MARIO_SOUND_PLAYED) ~= 0) then
        return
    end

    local animFrame = m.marioObj.header.gfx.animInfo.animFrame

    --Behavior for CHAR_SOUND_SNORING3
    if SNORE3_TABLE ~= nil and #SNORE3_TABLE >= 2 then
        --Exhale sound
        if animFrame == 2 and m.actionTimer < SLEEP_TALK_START then
            play_custom_character_sound(m, SNORE3_TABLE[2])

        --Inhale sound
        elseif animFrame == 25 then
            
            --Count up snores
            if #SNORE3_TABLE >= 3 then
                m.actionTimer = m.actionTimer + 1

                --End sleep-talk
                if m.actionTimer >= SLEEP_TALK_END then
                    m.actionTimer = STARTING_SNORE
                end
    
                --Enough snores? Start sleep-talk
                if m.actionTimer == SLEEP_TALK_START then
                    play_custom_character_sound(m, SNORE3_TABLE[3])
                
                --Regular snoring
                elseif m.actionTimer < SLEEP_TALK_START then
                    play_custom_character_sound(m, SNORE3_TABLE[1])
                end
            
            --Definitely regular snoring
            else
                play_custom_character_sound(m, SNORE3_TABLE[1])
            end
        end

    --No CHAR_SOUND_SNORING3, just use regular snoring
    elseif animFrame == 2 then
        play_character_sound(m, CHAR_SOUND_SNORING2)

    elseif animFrame == 25 then
        play_character_sound(m, CHAR_SOUND_SNORING1)
    end
end

hook_event(HOOK_MARIO_UPDATE, custom_character_snore)

------------------------------

local function use_custom_voice(m)
    local s = gPlayerSyncTable[m.playerIndex]
    return m.character.type == 1
end

--How many snores the sleep-talk has, or rather, how long the sleep-talk lasts
--If you omit the sleep-talk you can ignore this
local SLEEP_TALK_SNORES = 1

--Define what actions play what voice clips
--If an action has more than one voice clip, put those clips inside a table
--CHAR_SOUND_SNORING3 requires two or three voice clips to work properly...
--but you can omit it if your character does not sleep-talk
local CUSTOM_VOICETABLE = {
    	[CHAR_SOUND_OKEY_DOKEY] = 'LetsGo_L96.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'LetsGo_L96.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Jump3_L96.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Jump2_L96.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Punch3_L96.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Jump1_L96.ogg', 'Jump2_L96.ogg', 'Jump3_L96.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Hoohoo_L96.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Triple1_L96.ogg', 'LongJump_L96.ogg', 'Triple2_L96.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Uh_L96.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'LedgeAndLandLong_L96.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'LedgeAndLandLong_L96.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Haha_L96.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'LongJump_L96.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Doh_L96.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'FallLedge_L96.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'ClimbLedge_L96.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'LongFall_L96.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'Bingo_L96.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Groundpound_L96.ogg', 
	[CHAR_SOUND_HRMM] = 'PickUp_L96.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'HereWeGo_L96.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'SoLongBowser_L96.ogg', -- Throwing Bowser
 	[CHAR_SOUND_OOOF] = 'Oof_L96.ogg',
 	[CHAR_SOUND_OOOF2] = 'Oof_L96.ogg',
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Damaged_L96.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'LowPant_L96.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Lava_L96.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Tired_L96.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Yawn_L96.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'YawnInhale_L96.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'YawnExhale_L96.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'DreamTalk_L96.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Cough1_L96.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Cough1_L96.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Cough1_L96.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Dying_L96.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Drowning_L96.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Mamamia_L96.ogg' -- Booted out of level
}

--Define the table of samples that will be used for each player
--Global so if multiple mods use this they won't create unneeded samples
--DON'T MODIFY THIS SINCE IT'S GLOBAL FOR USE BY OTHER MODS!
gCustomVoiceSamples = {}
gCustomVoiceStream = nil

function stop_custom_character_sound(m, sound)
    local voice_sample = gCustomVoiceSamples[m.playerIndex]
    if voice_sample == nil or not voice_sample.loaded then
        return
    end

    audio_sample_stop(voice_sample)
    if voice_sample.file.relativePath:match('^.+/(.+)$') == sound then
        return voice_sample
    end
    -- audio_sample_destroy(voice_sample)
end

--Play a custom character's sound
--DON'T MODIFY THIS SINCE IT'S GLOBAL FOR USE BY OTHER MODS!
--- @param m MarioState
function play_custom_character_sound(m, voice)
    --Get sound, if it's a table, get a random entry from it
    local sound
    if type(voice) == "table" then
        sound = voice[math.random(#voice)]
    else
        sound = voice
    end
    if sound == nil then return 0 end

    --Get current sample and stop it
    local voice_sample = stop_custom_character_sound(m, sound)

    --If the new sound isn't a string, let's assume it's
    --a number to return to the character sound hook
    if type(sound) ~= "string" then
        return sound
    end

    --Load a new sample and play it! Don't make a new one if we don't need to
    if (m.area == nil or m.area.camera == nil) and m.playerIndex == 0 then
        if gCustomVoiceStream ~= nil then
            audio_stream_stop(gCustomVoiceStream)
            audio_stream_destroy(gCustomVoiceStream)
        end
        gCustomVoiceStream = audio_stream_load(sound)
        audio_stream_play(gCustomVoiceStream, true, 1)
    else
        if voice_sample == nil then
            voice_sample = audio_sample_load(sound)
        end
        audio_sample_play(voice_sample, m.pos, 1)

        gCustomVoiceSamples[m.playerIndex] = voice_sample
    end
    return 0
end

--Main character sound hook
--This hook is freely modifiable in case you want to make any specific exceptions
--- @param m MarioState
local function custom_character_sound(m, characterSound)
    if not use_custom_voice(m) or is_game_paused() then return end
    if characterSound == CHAR_SOUND_SNORING3 then return 0 end
    if characterSound == CHAR_SOUND_HAHA and m.hurtCounter > 0 then return 0 end

    local voice = CUSTOM_VOICETABLE[characterSound]
    if voice ~= nil then
        return play_custom_character_sound(m, voice)
    end
    return 0
end
hook_event(HOOK_CHARACTER_SOUND, custom_character_sound)

--Snoring logic for CHAR_SOUND_SNORING3 since we have to loop it manually
--This code won't activate on the Japanese version, due to MARIO_MARIO_SOUND_PLAYED not being set

local SNORE3_TABLE = CUSTOM_VOICETABLE[CHAR_SOUND_SNORING3]
local STARTING_SNORE = 46
local SLEEP_TALK_START = STARTING_SNORE + 49
local SLEEP_TALK_END = SLEEP_TALK_START + SLEEP_TALK_SNORES

--Main hook for snoring
--- @param m MarioState
local function custom_character_snore(m)
    if not use_custom_voice(m) then return end

    --Stop the snoring!
    if m.action ~= ACT_SLEEPING then
        if m.isSnoring > 0 then
            stop_custom_character_sound(m)
        end
        return

    --You're not in deep snoring
    elseif not (m.actionState == 2 and (m.flags & MARIO_MARIO_SOUND_PLAYED) ~= 0) then
        return
    end

    local animFrame = m.marioObj.header.gfx.animInfo.animFrame

    --Behavior for CHAR_SOUND_SNORING3
    if SNORE3_TABLE ~= nil and #SNORE3_TABLE >= 2 then
        --Exhale sound
        if animFrame == 2 and m.actionTimer < SLEEP_TALK_START then
            play_custom_character_sound(m, SNORE3_TABLE[2])

        --Inhale sound
        elseif animFrame == 25 then
            
            --Count up snores
            if #SNORE3_TABLE >= 3 then
                m.actionTimer = m.actionTimer + 1

                --End sleep-talk
                if m.actionTimer >= SLEEP_TALK_END then
                    m.actionTimer = STARTING_SNORE
                end
    
                --Enough snores? Start sleep-talk
                if m.actionTimer == SLEEP_TALK_START then
                    play_custom_character_sound(m, SNORE3_TABLE[3])
                
                --Regular snoring
                elseif m.actionTimer < SLEEP_TALK_START then
                    play_custom_character_sound(m, SNORE3_TABLE[1])
                end
            
            --Definitely regular snoring
            else
                play_custom_character_sound(m, SNORE3_TABLE[1])
            end
        end

    --No CHAR_SOUND_SNORING3, just use regular snoring
    elseif animFrame == 2 then
        play_character_sound(m, CHAR_SOUND_SNORING2)

    elseif animFrame == 25 then
        play_character_sound(m, CHAR_SOUND_SNORING1)
    end
end

hook_event(HOOK_MARIO_UPDATE, custom_character_snore)